package be.c4j.graphqldemo.graphqldemo.graphql;

import be.c4j.graphqldemo.graphqldemo.persistence.domain.Product;
import be.c4j.graphqldemo.graphqldemo.persistence.repository.OrderRepository;
import be.c4j.graphqldemo.graphqldemo.persistence.repository.ProductRepository;
import graphql.schema.DataFetcher;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class GraphQLDataFetchers {

    private ProductRepository productRepository;

    private OrderRepository orderRepository;


    public GraphQLDataFetchers(ProductRepository productRepository, OrderRepository orderRepository, ApplicationContext appContext) {
        this.productRepository = productRepository;
        this.orderRepository = orderRepository;
    }

    DataFetcher productDataFetcher = environment -> {
        List<Map> productMapList = new ArrayList<>();

        String id = environment.getArgument("id");

        List<Product> products;
        if ( id == null )
            products = productRepository.findAll();
        else
            products = productRepository.findAllById(Collections.singletonList(Long.valueOf(id)));

        for (Product product : products) {
            Map<String, Object> objectMap = new HashMap<>();
            objectMap.put("id", product.getId());
            objectMap.put("name", product.getName());
            objectMap.put("quantity", product.getStockQuantity());
            objectMap.put("description", product.getDescription());
            objectMap.put("imageUrl", product.getImageUrl());

            productMapList.add(objectMap);
        }

        return productMapList;
    };

    DataFetcher orderDataFetcher = environment -> {
        String id = environment.getArgument("id");

        return id == null ? orderRepository.findAll() : orderRepository.findAllById(Collections.singletonList(Long.valueOf(id)));
    };
}
